/*
    WARNING: This file was generated automatically.
    Do not modify it or your changes will be overwritten!
    Modify features.def instead.
*/

#ifndef ESPRESSO_SRC_CONFIG_CONFIG_FEATURES_HPP
#define ESPRESSO_SRC_CONFIG_CONFIG_FEATURES_HPP

/*********************************/
/* Handle definitions from CMake */
/*********************************/

#include "cmake_config.hpp"
#include "myconfig-final.hpp"

// CUDA is external
#if defined(CUDA)
#undef CUDA
#endif

// FFTW is external
#if defined(FFTW)
#undef FFTW
#endif

// GSL is external
#if defined(GSL)
#undef GSL
#endif

// H5MD is external
#if defined(H5MD)
#undef H5MD
#endif

// SCAFACOS is external
#if defined(SCAFACOS)
#undef SCAFACOS
#endif

// STOKESIAN_DYNAMICS is external
#if defined(STOKESIAN_DYNAMICS)
#undef STOKESIAN_DYNAMICS
#endif

#include "cmake_config.hpp"

/***********************/
/* Handle implications */
/***********************/

// DIPOLES implies ROTATION
#if defined(DIPOLES) && !defined(ROTATION)
#define ROTATION
#endif

// EK_BOUNDARIES implies ELECTROKINETICS
#if defined(EK_BOUNDARIES) && !defined(ELECTROKINETICS)
#define ELECTROKINETICS
#endif

// EK_BOUNDARIES implies ELECTROSTATICS
#if defined(EK_BOUNDARIES) && !defined(ELECTROSTATICS)
#define ELECTROSTATICS
#endif

// EK_BOUNDARIES implies EXTERNAL_FORCES
#if defined(EK_BOUNDARIES) && !defined(EXTERNAL_FORCES)
#define EXTERNAL_FORCES
#endif

// EK_BOUNDARIES implies LB_BOUNDARIES_GPU
#if defined(EK_BOUNDARIES) && !defined(LB_BOUNDARIES_GPU)
#define LB_BOUNDARIES_GPU
#endif

// ELECTROKINETICS implies ELECTROSTATICS
#if defined(ELECTROKINETICS) && !defined(ELECTROSTATICS)
#define ELECTROSTATICS
#endif

// ELECTROKINETICS implies EXTERNAL_FORCES
#if defined(ELECTROKINETICS) && !defined(EXTERNAL_FORCES)
#define EXTERNAL_FORCES
#endif

// ENGINE implies EXTERNAL_FORCES
#if defined(ENGINE) && !defined(EXTERNAL_FORCES)
#define EXTERNAL_FORCES
#endif

// ENGINE implies ROTATION
#if defined(ENGINE) && !defined(ROTATION)
#define ROTATION
#endif

// GAY_BERNE implies ROTATION
#if defined(GAY_BERNE) && !defined(ROTATION)
#define ROTATION
#endif

// LENNARD_JONES_GENERIC implies LENNARD_JONES
#if defined(LENNARD_JONES_GENERIC) && !defined(LENNARD_JONES)
#define LENNARD_JONES
#endif

// LJGEN_SOFTCORE implies LENNARD_JONES_GENERIC
#if defined(LJGEN_SOFTCORE) && !defined(LENNARD_JONES_GENERIC)
#define LENNARD_JONES_GENERIC
#endif

// PARTICLE_ANISOTROPY implies ROTATION
#if defined(PARTICLE_ANISOTROPY) && !defined(ROTATION)
#define ROTATION
#endif

// ROTATIONAL_INERTIA implies ROTATION
#if defined(ROTATIONAL_INERTIA) && !defined(ROTATION)
#define ROTATION
#endif

// SCAFACOS_DIPOLES implies DIPOLES
#if defined(SCAFACOS_DIPOLES) && !defined(DIPOLES)
#define DIPOLES
#endif

// STOKESIAN_DYNAMICS implies ROTATION
#if defined(STOKESIAN_DYNAMICS) && !defined(ROTATION)
#define ROTATION
#endif

// VIRTUAL_SITES_INERTIALESS_TRACERS implies VIRTUAL_SITES
#if defined(VIRTUAL_SITES_INERTIALESS_TRACERS) && !defined(VIRTUAL_SITES)
#define VIRTUAL_SITES
#endif

// VIRTUAL_SITES_RELATIVE implies ROTATION
#if defined(VIRTUAL_SITES_RELATIVE) && !defined(ROTATION)
#define ROTATION
#endif

// VIRTUAL_SITES_RELATIVE implies VIRTUAL_SITES
#if defined(VIRTUAL_SITES_RELATIVE) && !defined(VIRTUAL_SITES)
#define VIRTUAL_SITES
#endif

/*****************************************************/
/* Warn when derived switches are specified manually */
/*****************************************************/

// DIPOLAR_BARNES_HUT equals DIPOLES and ROTATION and CUDA
#ifdef DIPOLAR_BARNES_HUT
#warning DIPOLAR_BARNES_HUT is a derived switch and should not be set manually!
#elif defined(DIPOLES)  &&  defined(ROTATION)  &&  defined(CUDA)
#define DIPOLAR_BARNES_HUT
#endif

// DIPOLAR_DIRECT_SUM equals DIPOLES and ROTATION and CUDA
#ifdef DIPOLAR_DIRECT_SUM
#warning DIPOLAR_DIRECT_SUM is a derived switch and should not be set manually!
#elif defined(DIPOLES)  &&  defined(ROTATION)  &&  defined(CUDA)
#define DIPOLAR_DIRECT_SUM
#endif

// DP3M equals DIPOLES and FFTW
#ifdef DP3M
#warning DP3M is a derived switch and should not be set manually!
#elif defined(DIPOLES)  &&  defined(FFTW)
#define DP3M
#endif

// P3M equals ELECTROSTATICS and FFTW
#ifdef P3M
#warning P3M is a derived switch and should not be set manually!
#elif defined(ELECTROSTATICS)  &&  defined(FFTW)
#define P3M
#endif


extern char const *const FEATURES[];
extern char const *const FEATURES_ALL[];
extern unsigned int const NUM_FEATURES;
extern unsigned int const NUM_FEATURES_ALL;

#endif
